/* mbed Microcontroller Library
 * Copyright (c) 2019 ARM Limited
 * SPDX-License-Identifier: Apache-2.0
 */

#include "mbed.h"
//#include "Motor.h"
#include <cstdio>
#include <string>
#include "Servo.h"

#define MID         1500
#define MIN         1000
#define MAX         2000
#define STEP          50
#define TIME         100
#define BLINKING_RATE     300ms

DigitalOut led(D13);
I2CSlave slave(D4,D5);
Servo myservo1(PA_1);
Servo myservo2(PA_3);
//Motor turnn(PA_8, PA_11); //fan d9 d10

void wheel_con(char dir){
    if(dir == 'l'){
        printf("servo: on\n");
        while(true){
            //myServo1.pulsewidth_us(1500);
            //myServo2.pulsewidth_us(1500);
            wait_us(1000000);
        }
 
    }
}


class Motor
{
protected:
  PwmOut pwmPin;
  DigitalOut dirPin;  
  float lastVal;
  
public:

  Motor(PinName pwm,PinName dir): pwmPin(pwm), dirPin(dir) 
  {
  }
   
  void write(float Val)
   {
      if (Val >= 0) {
        dirPin = 1;
        pwmPin = Val;
        }else {
            dirPin = 0;
            pwmPin = -1 * Val;
    }
    lastVal = Val;
 }
   
//   float read()
//    {
//         return lastVal;
//         //printf("%f", lastVal);
//    }
   
};

Motor turnn(PA_8, PA_11); //fan d9 d10

bool power = false; //init: off
bool fan_power = false; //init: off
bool fann = true;
int fan_init = 0;
void fan_motor(int Val){

    //turn on: Val = 1
    //printf("i'm here _fan on\n");
    turnn.write(Val);

}

void test_print(int vv){
    printf("hi \n");
}

int Val = 0;

int main() {
    char buf[20];
    //fan_motor(Val);
    //printf("STM32 started...\n");
    slave.address(0xA0); // actual address = 0x50 (last bit ignored)
    //int Val = 0;
    //turnn.write(-1);
    wait_us(200000);
    while (1) {
        int i = slave.receive();
        //printf("receive: %d\n", i);
        //for(int i = 0; i < sizeof(buf); i++) buf[i] = 0; // Clear buffer
        switch (i) {
            case I2CSlave::ReadAddressed:
                printf("sgdj");
                
                break;
            case I2CSlave::WriteAddressed:
                slave.read(buf,sizeof(buf)-1);

                int byte_read = slave.read();
                int x;
                x = slave.read(buf,0);
                x= atoi(buf);
                printf("slave get: %d\n", x);
                int j =0;
        
                // fan_motor(1);
                // slave.read(buf,sizeof(buf)-1);
                myservo1.calibrate(0.0005,45.0);
                myservo2.calibrate(0.0005,45.0);
                
                if(x==65){
		        //     //turn.write(!fan_power);
                   // printf("x to fan on now");
                    //test_print(1);
                    turnn.write(90);
                    myservo1.calibrate(0.0005,45.0);
                    myservo2.calibrate(0.0005,45.0);

                    wait_us(20000);
                    
                    //Val = 1; 
                //     fan_power = !fan_power;
                    //fan_motor(1);
                //     ThisThread::sleep_for(BLINKING_RATE);
                //     //fan_motor(1);
                }
		        // }else{
                //     fan_power = !fan_power;
                // }
                //printf("Read: %s\n", buf);
                else if(x==66){
                    printf("forward \n");
                    myservo2 = -1;
                    myservo1 = 1;
                    wait_us(20000);
                } else if(x==67){
                    printf("backward \n");
                    myservo2 = 1;
                    myservo1 = -1;
                    wait_us(20000);
                    //turn.write(!fan_power);
                    
                }else if(x==68){
                    printf("turn left \n");
                
                    for(float p=1.0; p>0; p -= 0.2) {
                        myservo2 = p;
                        wait_us(20000);
                    }
                    wait_us(20000);
                    //turn.write(!fan_power);
                  
                }else if(x==69){
                     printf("turn right \n");
                
                    for(float p=1.0; p>0; p -= 0.2) {
                        myservo1 = p;
                        myservo2 = -p;
                        wait_us(20000);
                    }
                    wait_us(20000);
                    //turn.write(!fan_power);
                }else if(x==70){
                    printf("stop \n"); 
                      
                }else{
                     printf("non \n");
                 }
                break;
        }
    }
}