#include <cstdio>
#include <cstdlib>
#include <mbed.h>

DigitalOut led(D13);
DigitalIn sw(D3,PullUp);
I2CSlave slave(D4,D5);
#define BUFFER_SIZE 3

AnalogIn   f1(A0);
AnalogIn   f2(A1);
AnalogIn   f3(A2);
AnalogIn   f4(A6);
AnalogIn   f5(A3);

int t1;int t2;int t3;int t4;int t5;
int a1;int a2;int a3;int a5;
int a4=1;
char operation;

void checkFinger() {
    if(t1>=5000){ 
        a1=1;
    }else { a1=0;}

    if(t2>=60000) {
        a2=1;
    }else { a2=0;}

    if(t3>=58000) {
        a3=1;
    }else { a3=0;}
    
    if(t5>=60000) {
        a5=1;
    }else { a5=0;}
}

void opConfig() {
    if(a1==1 && a2==1 && a3==1 && a4 ==1 && a5==1){
        operation = 'A';
    }
    else if(a1==0 && a2==1 && a3==1 && a4 ==1 && a5==1){
        operation = 'B';
    }
    else if(a1==0 && a2==0 && a3==1 && a4 ==1 && a5==1){
        operation = 'C';
    }
    else if(a1==0 && a2==0 && a3==0 && a4 ==1 && a5==1){
        operation = 'D';
    }
    else if(a1==0 && a2==1 && a3==1 && a4 ==1 && a5==0){
        operation = 'E';
    }
    else if(a1==0 && a2==0 && a3==1 && a4 ==1 && a5==0){
        operation = 'F';
    }
}


int main() {
    char buf[BUFFER_SIZE] = "4";
    slave.address(0xA0);
    while (1) {
        t1 = f1.read_u16();
        t2 = f2.read_u16();
        t3 = f3.read_u16();
        t4 = f4.read_u16();
        t5 = f5.read_u16();
        // printf("val1: %d\n",t1);
        // printf("val2: %d\n",t2);
        // printf("val3: %d\n",t3);
        // printf("val4: %d\n",t4);
        // printf("val5: %d\n",t5);
        // printf("----------------\n");
        // wait_us(5000000);
        int i = slave.receive();

        checkFinger();
        opConfig();
        
        // printf("thumb stat: %d\n",a1);
        // printf("index stat: %d\n",a2);
        // printf("middle stat: %d\n",a3);
        // printf("ring stat: %d\n",a4);
        // printf("pinky stat: %d\n",a5);
        //t1 = f1.read_u16();
        //wait_us(5000000);
        switch (i) {
            case I2CSlave::ReadAddressed:
                //printf("val: %d\n",t1);
                if(operation == 'A'){
                    slave.write("A", 3);
                }else if(operation == 'B') {
                    slave.write("B", 3);
                }else if(operation == 'C') {
                    slave.write("C", 3);
                }else if(operation == 'D') {
                    slave.write("D", 3);
                }else if(operation =='E') {
                    slave.write("E", 3);
                }else if(operation =='F') {
                    slave.write("F", 3);
                }else{
                    slave.write("G", 3);
                }
                break;
            case I2CSlave::WriteGeneral:
                slave.read(buf, BUFFER_SIZE);
                printf("Read from master (general): %s\n", buf);
                break;
            case I2CSlave::WriteAddressed:
                slave.read(buf, BUFFER_SIZE);
                printf("Read from master (addressed): %s\n", buf);
                break;
        }
        //wait_us(5000000);
    }
        //wait_us(5000000);
    }