import network
from esp import espnow
import time

from machine import Pin, I2C
from ssd1306 import SSD1306_I2C

w0 = network.WLAN(network.STA_IF)  # Or network.AP_IF
w0.active(True)

def tx(result):
    mac, sent = result
    print("send: %s - %r" % (mac,sent))

e = espnow
e.init()
peer = b'\xFF\xFF\xFF\xFF\xFF\xFF'   # MAC address of peer's wifi interface
e.add_peer(peer)

espnow.on_send(tx)
espnow.pmk('0123456789abcdef')
#e.send("Starting...")       # Send to all peers

i2c = I2C(scl=Pin(22),sda=Pin(21),freq=100000)
oled = SSD1306_I2C(128,64,i2c)
# oled.fill(0)
oled.text("ESP32 started...",0,0)
oled.show()
print("Scanning I2C bus... found",i2c.scan())
time.sleep(3)
print("Receive data to STM32...")
#i2c.writeto(60, b'hi esp32')
while True:
    time.sleep(5 )
    result = i2c.readfrom(0x50, 1)
    print(chr(result[0]))
    e.send(peer, chr(result[0]))
    
